#include <amxmodx>
#include <fun>
#include <cstrike>
#include <engine>

#define PLUGIN	"C4man with fun"
#define AUTHOR	"Biscuit"
#define VERSION	"1.2"


new bool:c4spawn
new bool:shadow[33]
new g_maxplayers
new C4man,visible,movespeed,nofootstep
new View3rd

public plugin_init()
{
	register_plugin(PLUGIN,VERSION,AUTHOR)
	C4man = register_cvar("amx_C4man","1")
	nofootstep = register_cvar("amx_C4mannofs","1")
	visible = register_cvar("amx_C4manvisible","15")
	movespeed = register_cvar("amx_C4mansp","150")
	View3rd = register_cvar("amx_C4man3rd","1")
	register_clcmd("say /shadow","TurnOnShadow")
	register_dictionary("C4man_with_fun.txt")
	register_event("CurWeapon","check_wpn","be")
	register_event("TextMsg", "checkplayer", "a", "2=#Bomb_Planted")
	register_logevent("checkplayer", 3, "2=Dropped_The_Bomb")
	register_logevent("checkplayer", 2, "1=Round_Start")
	register_logevent("round_end_event", 2, "1=Round_End")
	g_maxplayers = get_maxplayers()
}

public plugin_precache()
{
	precache_model("models/rpgrocket.mdl")
}

public TurnOnShadow(id)
{
	if(shadow[id] == false)
	{
	client_print(id,print_chat, "%L", id, "ShadowOn")
	client_cmd(id,"cl_shadows 1")
	shadow[id] = true
	}
	else
	{
	client_print(id,print_chat, "%L", id, "ShadowOff")
	client_cmd(id,"cl_shadows 0")
	shadow[id] = false
	}
	return PLUGIN_HANDLED
}

public client_putinserver(id)
{
	if(get_pcvar_num(C4man))
	{
	set_task(10.0, "printshadowtips", id)
	}
}

public printshadowtips(id)
{
	client_print(id,print_chat, "%L", id, "ShadowTips")
	shadow[id] = false
}
public checkplayer()
{
	if(get_pcvar_num(C4man))
	{
		c4spawn = true
		for(new id = 1; id <= g_maxplayers; ++id)
		{
			set_task(0.5,"check_wpn",id)
		}
	}
}
public round_end_event()
{
	if(get_pcvar_num(C4man))
	{
		c4spawn = false
	}
}

public check_wpn(id){
	if(!is_user_alive(id) || c4spawn == false || !get_pcvar_num(C4man))
	     return PLUGIN_HANDLED
	new Float:speed = get_user_maxspeed(id)
	new weapon = get_user_weapon(id)
	new name[32]
	get_user_name(id,name,31)
	if(weapon == CSW_C4){
		set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderTransAlpha,get_pcvar_num(visible))
		set_user_maxspeed(id, get_pcvar_float(movespeed))
		set_user_footsteps(id,get_pcvar_num(nofootstep))
		client_print(0, print_chat, "%L", id, "C4holding",name);
		if(get_pcvar_num(View3rd))
		{
			set_view(id,CAMERA_3RDPERSON)
		}
	}else{
		set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,25)
		set_user_maxspeed(id, speed)
		set_user_footsteps(id,0)
		if(get_pcvar_num(View3rd))
		{
			set_view(id,CAMERA_NONE)
		}
	}
	return PLUGIN_HANDLED
}
